<?php
use WHMCS\Database\Capsule as DB;
//Recently modified by Krzysztof Galanty <krzysztof.ga@modulesgarden.com> on 21-09-2017 v1.2.5
if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}

function myException($exception) {
  echo "<b>Error:</b> " . $exception->getMessage();
}
set_exception_handler('myException');
function synergywholesale_ssl_renameModule($names_map) {
    foreach ($names_map as $old=>$new) {
        $products_ssl = DB::table('tblproducts')->where('servertype', $old)->select('id')->get();
        if ($products_ssl)
            foreach ($products_ssl as $pr) {
                DB::table('tblproducts')->where('id', $pr->id)->update(['servertype' => $new]);
            }
    }
}

function synergywholesale_ssl_ConfigOptions($params) {
   $relid = isset($_POST['id']) ? $_POST['id'] : $_GET['id'];
   $fieldExists =  DB::table('tblcustomfields')->where('relid',$relid)->count();

   if(!$fieldExists)
   {
        $data = ['type' => 'product',
                    'relid' => $relid,
                    'fieldname' => 'privKey|Private Key',
                    'fieldtype' => 'textarea',
                    'adminonly' => 'on'];

        DB::table('tblcustomfields')->insert($data);
   }

    $result = DB::table('tblemailtemplates')->where('name', "SSL Certificate Configuration Required")->first();

    if (count($result) == 0) {
        DB::table('tblemailtemplates')->insert([
            'type' => 'product',
            'name' => 'SSL Certificate Configuration Required',
            'subject' => 'SSL Certificate Configuration Required',
            'message' => '<p>Dear {\$client_name},</p><p>Thank you for your order for an SSL Certificate. Before you can use your certificate, it requires configuration which can be done at the URL below.</p><p>{\$ssl_configuration_link}</p><p>Instructions are provided throughout the process but if you experience any problems or have any questions, please open a ticket for assistance.</p><p>{\$signature}</p>',
            'fromname' => '',
            'fromemail' => '',
            'disabled' => '',
            'custom' => '',
            'language' => '',
            'copyto' => '',
            'plaintext' => '0'
        ]);
    }
    //script to remove value of '3' on Validity Period dropdown if SSL Certificate Type == Trustwave Domain Validated SSL - as this pair together is unsupported according to API doc
    $injected_js = "<script>jQuery('select[name=\"packageconfigoption[3]\"]').change(function() {   if(jQuery('select[name=\"packageconfigoption[3]\"]').val() == 'Trustwave Premium EV SSL') {".
            "jQuery('select[name=\"packageconfigoption[4]\"]').find('option').each(function() {  if($(this).val()==3) $(this).remove();  }); } ".
            "else { if(jQuery('select[name=\"packageconfigoption[4]\"]').find('option').length < 3) $('select[name=\"packageconfigoption[4]\"]').append('<option value=\"3\">3</option>'); } ".
            "}); (function($) { if(jQuery('select[name=\"packageconfigoption[3]\"]').val()=='Trustwave Premium EV SSL'){ jQuery('select[name=\"packageconfigoption[4]\"]').find('option').each(function() {  if(jQuery(this).val()==3) jQuery(this).remove();  }); } } )(jQuery);</script>";
    $configarray = array(
	"API Key" => array("Type" => "text", "Size" => "60",),
        "Reseller ID" => array("Type" => "text", "Size" => "10",),
        "SSL Certificate Type" => array("Type" => "dropdown", "Options" => "Trustwave Domain Validated SSL,Trustwave Premium SSL,Trustwave Enterprise SSL,Trustwave Premium Wildcard SSL,Trustwave Premium EV SSL",),
        "Validity Period" => array("Type" => "dropdown", "Options" => "1,2,3", "Description" => "Years".$injected_js,),
        "Test Mode" => array("Type" => "yesno",),
    );
    return $configarray;
}

function synergywholesale_ssl_CreateAccount($params) {
    $result = DB::table('tblsslorders')->where('serviceid', $params["serviceid"])->count();
    if ($result > 0) {
        return "An SSL Order already exists for this order";
    }
    $sslorderid = DB::table('tblsslorders')->insertGetId([
        "userid" => $params["clientsdetails"]["userid"],
        "serviceid" => $params["serviceid"],
        "remoteid" => "",
        "module" => "synergywholesale_ssl",
        "certtype" => $params["configoption3"],
        "status" => "Awaiting Configuration"
    ]);

    global $CONFIG;
    $sslconfigurationlink = $CONFIG["SystemURL"] . "/configuressl.php?cert=" . md5($sslorderid);
    $sslconfigurationlink = "<a href=\"$sslconfigurationlink\">$sslconfigurationlink</a>";
    sendMessage("SSL Certificate Configuration Required", $params["serviceid"], array("ssl_configuration_link" => $sslconfigurationlink));

    return "success";
}

function synergywholesale_ssl_AdminCustomButtonArray() {
    $buttonarray = array(
        "Cancel" => "cancel",
        "Resend Configuration Email" => "resend",
        "Resend Approval Email" => "resendapprover",
        "Resend Completed Certificate Email" => "resendcompleted",
    );
    return $buttonarray;
}

function synergywholesale_ssl_ClientAreaCustomButtonArray() {
    $buttonarray = array(
        "Decode CSR" => "decodecsr",
        "Request New Certificate" => "reissue",
        "Resend Approval Email" => "resendapprover",
        "Resend Completed Certificate Email" => 'resendcompleted'
    );
    return $buttonarray;
}

function synergywholesale_ssl_decodecsr($params) {
    $resellerid = $params['configoption2'];
    $apikey = $params['configoption1'];
    $testmode = $params['configoption5'];
    $data = DB::table('tblsslorders')->where('serviceid', $params['serviceid'])->select('remoteid')->first();
    $certID = $data->remoteid; //zrefaktoryzowac ten fragment do innej funkcji
    $data = ['resellerID' => $resellerid, 'apiKey' => $apikey, 'certID' => $certID];
    $a = synergywholesale_ssl_api('SSL_getCertSimpleStatus', $data, $testmode);
    $certs = $a->certStatus;   

    if (isset($_POST['csr_string'])) {
        $resellerid = $params["configoption2"];
        $apikey = $params["configoption1"];

        $data = [
            'resellerID' => $resellerid,
            'apiKey' => $apikey,
            'csr' => $_POST['csr_string']
        ];

        $output = synergywholesale_ssl_api('SSL_decodeCSR', $data, $testmode);
		
        if ($output->status != 'OK')
            return $output->errorMessage;
    }
    return array(
        'templatefile' => 'csr_form',
        'vars' => array(
            'certs' => $certs,
            'parsedcsr' => $output,
        ),
    );
}

function synergywholesale_ssl_cancel($params) {

    list($certID, $status) = synergywholesale_ssl_getService($params['serviceid']);

    if (!$certID)
        return "No SSL Order exists for this service";
//    if ($status != "Awaiting Configuration")
//        return "Only SSL Orders in Awaiting Configuration status can be cancelled";

    $resellerid = $params["configoption2"];
    $apikey = $params["configoption1"];
    $ssltype = $params["configoption3"];
    $validityperiod = $params["configoption4"];
    $testmode = $params["configoption5"];

    $data = [
        'resellerID' => $resellerid,
        'apiKey' => $apikey,
        'certID' => $certID
    ];

    $checkStatus = synergywholesale_ssl_api('SSL_getCertSimpleStatus', $data, $testmode);
    if($checkStatus->certStatus != 'PENDING')    
        return 'Only SSL Orders in Pending status can be cancelled';
    
    $output = synergywholesale_ssl_api('SSL_cancelSSLCertificate', $data, $testmode);
      if ($output->status == "OK") {
        DB::table('tblsslorders')
                ->where('serviceid', $params["serviceid"])
                ->update([
                    "status" => 'Cancelled'
        ]);
        DB::table('tblhosting')
                ->where('id', $params["serviceid"])
                ->update([
                    "domainstatus" => 'Cancelled'
        ]);
        return "success";
    } else {
        $error = $output->errorMessage;
        if (!$error)
            $error = "An Unknown Error Occurred";
        return $error;
    }
}

function synergywholesale_ssl_resend($params) {
    $data = DB::table('tblsslorders')->where('serviceid', $params['serviceid'])->select('id')->first();

    $id = $data->id;
    if (!$id) {
        return "No SSL Order exists for this product";
    }
    global $CONFIG;
    $sslconfigurationlink = $CONFIG["SystemURL"] . "/configuressl.php?cert=" . md5($id);
    $sslconfigurationlink = "<a href=\"$sslconfigurationlink\">$sslconfigurationlink</a>";
 
    /*     * ***********************************
     * EDITED BY MODULESGARDEN (05-02-2014)
     * Custom Modification for
     * VentraIP SSL Module 
     * START
     * *********************************** */
    // check if email was send
    if (sendMessage("SSL Certificate Configuration Required", $params["serviceid"], array("ssl_configuration_link" => $sslconfigurationlink))) {
        // if email was sent, return success
        return "success";
    } else {
        // or general error, because to function didn't return error messages or etc
        return "Cannot send email";
    }

    /*     * ***********************************
     * EDITED BY MODULESGARDEN (05-02-2014)
     * Custom Modification for
     * VentraIP SSL Module 
     * END
     * *********************************** */
}

function synergywholesale_ssl_resendapprover($params) {
    $data = DB::table('tblsslorders')->where('serviceid', $params['serviceid'])->select('remoteid', 'status')->first();
    $certID = $data->remoteid;
    $status = $data->status;

    if (!$certID)
        return "No SSL Order exists for this service";
    if ($status != "Completed")
        return "Only SSL Orders in Completed status can be resent approval emails";

    $resellerid = $params["configoption2"];
    $apikey = $params["configoption1"];
    $ssltype = $params["configoption3"];
    $validityperiod = $params["configoption4"];
    $testmode = $params["configoption5"];


    $data = array(
        'resellerID' => $resellerid,
        'apiKey' => $apikey,
        'certID' => $certID
    );
	
    $output = synergywholesale_ssl_api('SSL_resendDVEmail', $data, $testmode);
	
    if ($output->status == "OK") {
        return "success";
    } else {
        $error = $output->errorMessage;
        if (!$error)
            $error = "An Unknown Error Occurred";
        return $error;
    }
}

function synergywholesale_ssl_reissue($params) {

    $resellerid = $params["configoption2"];
    $apikey = $params["configoption1"];
    $ssltype = $params["configoption3"];
    $validityperiod = $params["configoption4"];
    $testmode = $params["configoption5"];


    if (isset($_POST['email'])) 
    {

        if ($_POST['generateNew'] == 'on') 
        {
			
            $data = array(
                'resellerID' => $resellerid,
                'apiKey' => $apikey,
                'numOfYears' => $validityperiod,
                'city' => $_POST['city'],
                'state' => $_POST['state'],
                'country' => $_POST['country'],
                'organisation' => $_POST['orgname'],
                'organisationUnit' => $_POST['orgunit'],
                'commonName' => $_POST['Domain'],
                'emailAddress' => $_POST['email'],
            );
            
            $output = synergywholesale_ssl_api('SSL_generateCSR', $data, $testmode);

            if ($output->status != 'OK')
            {
                return $output->errorMessage;
            }

            DB::table('tblcustomfieldsvalues')->where('relid',$params['serviceid'])->update(['value' => $output->privKey]);

            $newCSR = $output->csr;

            }
            elseif(isset($_POST['csr'])) 
            {
                $newCSR = $_POST['csr'];
            }

            list($certID, $status) = synergywholesale_ssl_getService($params['serviceid']);
            
          
            $data = ['resellerID' => $resellerid, 
                    'apiKey' => $apikey, 
                    'certID' => $certID,
                    'newCSR' => $newCSR];

            $output = synergywholesale_ssl_api('SSL_reissueCertificate', $data, $testmode);
 
            if ($output->status == 'OK') 
            {
                DB::table('tblsslorders')->where('serviceid', $params['serviceid'])->update(['remoteid' => $output->newCertID]);
                return array(
                'templatefile' => 'reissue_completed',
                'vars' => array(
                    'cer' => $output->cer,
                    'p7b' => $output->p7b,
                    'status' => $output->status,
                ),
            );
        }
        if($output->status !== 'OK')
			return $output->errorMessage;
    }

 return array(
        'templatefile' => 'reissue',
        'breadcrumb' => array(
            'stepurl.php?action=this&var=that' => 'Request New Certificate',
        ),
        'vars' => array(
            'serviceid' => $params['serviceid'],
            'city' => $params['clientsdetails']['city'],
            'state' => $params['clientsdetails']['state'],
            'country' => $params['clientsdetails']['countryname'],
			'code' => $params['clientsdetails']['countrycode'],
            'organisation' => $params['clientsdetails']['companyname'],
            'commonName' => $params['domain'],
            'email' => $params['clientsdetails']['email'],
        ),
    ); 

}

function synergywholesale_ssl_api($action, $data, $testmode) {
    if ($testmode)
        $url = 'https://api-ote.synergywholesale.com/?wsdl';
    else
        $url = 'https://api.synergywholesale.com/?wsdl';

    $client = new SoapClient(NULL, array('location' => $url, 'uri' => ""));
    $output = $client->$action($data);
    logModuleCall('Synergy Wholesale SSL', $action, $data, (array)$output);
    return $output;
}
function synergywholesale_ssl_getService($serviceid) {
        $data = DB::table('tblsslorders')->where('serviceid', $serviceid)->select('remoteid', 'status')->first();
    $certID = $data->remoteid;
    $status = $data->status;
    return [$certID, $status];
}
function synergywholesale_ssl_resendcompleted($params) {
    list($certID, $status) = synergywholesale_ssl_getService($params['serviceid']);

    if (!$certID)
        return "No SSL Order exists for this service";
    if ($status != "Completed")
        return "Only SSL Orders in Completed status can be resent completed certificate emails";

    $resellerid = $params["configoption2"];
    $apikey = $params["configoption1"];
    $ssltype = $params["configoption3"];
    $validityperiod = $params["configoption4"];
    $testmode = $params["configoption5"];

    $data = array(
        'resellerID' => $resellerid,
        'apiKey' => $apikey,
        'certID' => $certID
    );

    $output = synergywholesale_ssl_api('SSL_resendIssuedCertificateEmail', $data, $testmode);
    if ($output->status == "OK") {
        return "success";
    } else {
        $error = $output->errorMessage;
        if (!$error)
            $error = "An Unknown Error Occurred";
        return $error;
    }
}

/* * ***********************************
 * EDITED BY MODULESGARDEN (05-02-2014)
 * Custom Modification for
 * VentraIP SSL Module 
 * START
 * *********************************** */

/**
 * Default WHMCS function which provide output in client area product details
 * @global type $_LANG      global variable with actual lang
 * @param type $params      WHMCS variables
 * @return string           html code to show
 */

function synergywholesale_ssl_ClientArea($params) {
    add_hook('ClientAreaPrimarySidebar', 1, function (WHMCS\View\Menu\Item $primarySidebar) use($params) {


        $panel = $primarySidebar->getChild('Service Details Overview');
    	


        if (is_a($panel, 'WHMCS\View\Menu\Item')) {
            $panel = $panel->getChild('Information');
            if (is_a($panel, 'WHMCS\View\Menu\Item')) {
                $panel->setUri("clientarea.php?action=productdetails&id={$params['serviceid']}");
                $panel->setAttributes(array());
            }
        }
    });
  
    if ($params['status'] == 'Completed') {
        DB::table('tblhosting')->where('id', $params["serviceid"])->update(['domainstatus' => 'Active']);
        header('Location: clientarea.php?action=productdetails&id=' . $params['serviceid']);
        exit;
    }
         
            $resellerid = $params['configoption2'];
            $apikey = $params['configoption1'];
            $ssltype = $params['configoption3'];
            $validityperiod = $params['configoption4'];
            $testmode = $params['configoption5'];
            $data = DB::table('tblsslorders')->where('serviceid', $params['serviceid'])->select('remoteid')->first();
            $certID = $data->remoteid; //zrefaktoryzowac ten fragment do innej funkcji
            $data = ['resellerID' => $resellerid, 'apiKey' => $apikey, 'certID' => $certID];
            $a = synergywholesale_ssl_api('SSL_getCertSimpleStatus', $data, $testmode);
            $certs = $a->certStatus;     

            if ($_GET['method'] == 'certs') {  
            $output = synergywholesale_ssl_api('SSL_getSSLCertificate', $data, $testmode);
            
        if(isset($output->errorMessage)) 
        { 
            echo('<tr><td class="fieldarea">Error:</td><td>' . $output->errorMessage . '</td></tr>'); 
            die; 
        }
        $fieldid=DB::table('tblcustomfields')->where('fieldname','LIKE', 'privKey%')->where('relid', '=', $params['packageid'])->value('id');
            echo('<tr><td class="fieldarea">Certificate:</td><td><textarea class="form-control" rows="12" cols="90" readonly=true style="width: 610px; height: 260px;">' . $output->cer . '</textarea></td></tr>' .
            '<tr><td class="fieldarea">Certificate p7b:</td><td><textarea class="form-control" rows="12" cols="90" readonly=true style="width: 610px; height: 260px;">' . $output->p7b . '</textarea></td></tr>');
            $output = $output = DB::table('tblcustomfieldsvalues')->where('relid',$params['serviceid'])->where('fieldid', $fieldid)->value('value');
            echo ('<tr><td class="fieldarea">Private Key:</td><td><textarea class="form-control" rows="12" cols="90" readonly=true style="width: 610px; height: 260px;">' . $output . '</textarea></td></tr>');
            die();
        }
         if ($_GET['method'] == 'private') 
        {  
            $output = DB::table('tblcustomfieldsvalues')->where('relid',$params['serviceid'])->select('value')->first();
            echo ('<tr><td class="fieldarea">Private Key:</td><td><textarea class="form-control" rows="12" cols="90" readonly=true style="width: 610px; height: 260px;">' . $output->value . '</textarea></td></tr>');
            die();
        }
// get global variable
        global $_LANG;
        // mysql query to obtain data fot this ssl order
        $data = DB::table('tblsslorders')->where("serviceid", $params['serviceid'])->first();

        // extract variables from returned array
        extract((array) $data);

        //  NOW AVAILABLE:
        //  $id             as $data['id']                  int(10)
        //	$userid         as $data['userid']              int(10)
        //	$serviceid      as $data['serviceid']           int(10)
        //	$remoteid       as $data['remoteid']            text
        //	$module         as $data['module']              text
        //	$certtype       as $data['certtype']            text
        //	$configdata     as $data['configdata']          text
        //	$completiondate as $data['completiondate']	datetime
        //	$status         as $data['status']              text
        // if ssl order exist, just to be sure
        if ($data && $id) {
            // calculate provision date
            // we have only $completiondate variable wich is date when ssl certificate have been configured
            if ($completiondate == '0000-00-00 00:00:00') {
                $provisiondate = 'Not Yet Configured';
            } else {
                $provisiondate = date('d/m/Y', strtotime($completiondate));
			}
			
                // expiry date isnt storred in database, so we are calculating it based by Product Module Settings!
                // @warrning, if you have Validity Period set to 1 year, client will buy this product, and admin will change this
                // $expirydate date will be calculated WRONG
                // if there is set configurable option to this product with name "Years" (should be number)
                if (isset($params['configoptions']['Years'])) {
                    // grab value from configureble option set to module
                    $validityperiod = $params['configoptions']['Years'];					
                }  else {
					$validityperiod = $params['configoption4'];			                              
					}
				// calculate Expiry date 	
				$expirydate = date('d/m/Y', strtotime("+$validityperiod year", strtotime($completiondate)));
				
				if($completiondate == '0000-00-00 00:00:00')
				{
					$expirydate = '	Not Yet Created';
				} else {
					$expirydate = date('d/m/Y', strtotime("+$validityperiod year", strtotime($completiondate)));
				}
				
            // if certificat isnt configured
            if ($status == 'Awaiting Configuration') {
                $status .= ' - <a href="configuressl.php?cert=' . md5($id) . '"><strong>Configure Now</strong></a>';
            }


		return [		  
                'templatefile' => 'ca',
                 'vars' => [
                 'certs' => $certs,
		'provisiondate' => $provisiondate,
		'lang_sslstatus' => $_LANG['sslstatus'],
                'expirydate' => $expirydate,
			'status' => $status
        ],
   ];

		} else {
            // if product isn't created, this error will occur
            // if so, admin need to make "Create" action in product details (admin area)
            $output .= '<div class="alert alert-danger">
                       <p class="danger">Product must be created manually. Please contact with administrator.</p>
                   </div>';
        } return [		  
       'templatefile' => 'error',
        'vars' => [
		'error' => $output
        ],
   ];
}

/* * ***********************************
 * EDITED BY MODULESGARDEN (05-02-2014)
 * Custom Modification for
 * VentraIP SSL Module 
 * END
 * *********************************** */

function synergywholesale_ssl_SSLStepOne($params) {
    $fields['additionalfields']['Generate CSR']['csr_generate_check'] = [
        'FriendlyName' => 'Generate CSR',
        "Type" => "yesno",
        "Description" => 'If checked, new CSR will be generated based upon information below.<script>jQuery(\'[name="fields[csr_generate_check]"]\').on(\'change\', function() { jQuery(\'#inputCsr\').prop(\'readonly\', jQuery(this).prop(\'checked\'));} ); </script>',
        'Required' => false];
    $fields['additionalfields']['Generate CSR']['common_name'] = [
        'FriendlyName' => 'Common Name (Domain)',
        "Type" => "text",
        "Description" => '<script>jQuery(\'[name="fields[common_name]"]\').addClass(\'form-control\').val(\''.$params['domain'].'\'); jQuery(\'#inputServerType\').val(1031); setTimeout(function() { jQuery(jQuery(\'fieldset\')[1]).find(\'input\').each(function(){ if(jQuery(this).attr(\'name\') != \'address2\') jQuery(this).prop(\'required\',true); }); jQuery(\'form\').submit(function() { jQuery(\'input[type="submit"]\').prop(\'disabled\',true); });   }, 100);</script>',
        'Required' => false];
    return $fields;
}

/* * ***********************************
 * EDITED BY MODULESGARDEN (04-02-2014)
 * Custom Modification for
 * VentraIP SSL Module 
 * START
 * *********************************** */

/**
 * This was main problem, this function simply redirect client to next step (third one)
 * and submit form, WHMCS have bug itself in that section, so we need to redirect 
 * user manually, otherwise it will redirect all the time to main client area
 * 
 * Function is executed on submit first step in configure ssl certificate

 * FIXED AS OF WHMCS 7.4

function synergywholesale_ssl_SSLStepTwo($params) {

    $vars = http_build_query(array(
        'token' => $_REQUEST['token'],
        'cert' => $_REQUEST['cert'],
        'step' => '3',
    ));

    header('Location: configuressl.php?' . $vars);
    exit();
}

 */

/* * ***********************************
 * EDITED BY MODULESGARDEN (04-02-2014)
 * Custom Modification for
 * VentraIP SSL Module 
 * END
 * *********************************** */
function synergywholesale_ssl_Renew($params) {
    $resellerid = $params["configoption2"];
    $apikey = $params["configoption1"];
    $ssltype = $params["configoption3"];
    $validityperiod = $params["configoption4"];
    $testmode = $params["configoption5"];

    $webservertype = $params["servertype"];
    $csr = $params["csr"];
    $firstname = $params['clientsdetails']["firstname"];

    $lastname = $params['clientsdetails']["lastname"];
    //$orgname = $params['clientsdetails']["companyname"];
   
    $emailaddress = $params['clientsdetails']["email"];
    $address1 = $params['clientsdetails']["address1"];
    //$address2 = $params["address2"];
    $city = $params['clientsdetails']["city"];
    $state = $params['clientsdetails']["state"];
    $postcode = $params['clientsdetails']["postcode"];
    $country = $params['clientsdetails']["country"];
    $phonenumber = $params['clientsdetails']["phonenumber"];
   // $domain = $params['domain'];
    
    list($certID, $status) = synergywholesale_ssl_getService($params['serviceid']);
    
    $data = array(
            'resellerID' => $resellerid,
            'apiKey' => $apikey,
            'certID' => $certID,
            'firstName' => $firstname,
            'lastName' => $lastname,
            'emailAddress' => $emailaddress,
            'address' => $address1,
            'city' => $city,
            'state' => $state,
            'postCode' => $postcode,
            'country' => $country,
            'phone' => $phonenumber,
            'fax' => $phonenumber,
        );
     $output = synergywholesale_ssl_api('SSL_renewSSLCertificate', $data, $testmode);
     
     if($output->status == 'OK') {
         
         DB::table('tblsslorders')->where('serviceid', $params['serviceid'])->update(['remoteid'=> $output->certID]);
         return 'success';
     }
     else
     return $output->errorMessage;
}
function synergywholesale_ssl_SSLStepTwo($params) {

    $resellerid = $params["configoption2"];
    $apikey = $params["configoption1"];
    $ssltype = $params["configoption3"];
    $validityperiod = $params["configoption4"];
    $testmode = $params["configoption5"];

    $webservertype = $params["servertype"];
    $csr = $params["csr"];
    $firstname = $params["firstname"];

    $lastname = $params["lastname"];
    $orgname = $params["orgname"];
    $jobtitle = $params["jobtitle"];
    $emailaddress = $params["email"];
    $address1 = $params["address1"];
    $address2 = $params["address2"];
    $city = $params["city"];
    $state = $params["state"];
    $postcode = $params["postcode"];
    $country = $params["country"];
    $phonenumber = $params["phonenumber"];
    $domain = $params['domain'];

    /*
      SSL Cert Types + Product IDs
      55 Trustwave Domain Validated SSL - 1 Year
      56 Trustwave Domain Validated SSL - 2 Year
      57 Trustwave Domain Validated SSL - 3 Year
      58 Trustwave Premium SSL - 1 year
      59 Trustwave Premium SSL - 2 year
      60 Trustwave Premium SSL - 3 year
      61 Trustwave Enterprise SSL - 1 Year
      62 Trustwave Enterprise SSL - 2 Year
      63 Trustwave Enterprise SSL - 3 Year
      64 Trustwave Premium Wildcard SSL - 1 Year
      65 Trustwave Premium Wildcard SSL - 2 Year
      66 Trustwave Premium Wildcard SSL - 3 Year
      67 Trustwave Premium EV SSL - 1 Year
      68 Trustwave Premium EV SSL - 2 Year
     */

    if (isset($params['configoptions']['Years']))
        $validityperiod = $params['configoptions']['Years'];

    if ($ssltype == "Trustwave Domain Validated SSL") {
        if ($validityperiod == "1")
            $sslid = '55';
        if ($validityperiod == "2")
            $sslid = '56';
        if ($validityperiod == "3")
            $sslid = '57';
    } elseif ($ssltype == "Trustwave Premium SSL") {
        if ($validityperiod == "1")
            $sslid = '58';
        if ($validityperiod == "2")
            $sslid = '59';
        if ($validityperiod == "3")
            $sslid = '60';
    } elseif ($ssltype == "Trustwave Enterprise SSL") {
        if ($validityperiod == "1")
            $sslid = '61';
        if ($validityperiod == "2")
            $sslid = '62';
        if ($validityperiod == "3")
            $sslid = '63';
    } elseif ($ssltype == "Trustwave Premium Wildcard SSL") {
        if ($validityperiod == "1")
            $sslid = '64';
        if ($validityperiod == "2")
            $sslid = '65';
        if ($validityperiod == "3")
            $sslid = '66';
    } elseif ($ssltype == "Trustwave Premium EV SSL") {
        if ($validityperiod == "1")
            $sslid = '67';
        if ($validityperiod == "2")
            $sslid = '68';
    }

    if ($params['fields']["csr_generate_check"] == 'on') { //generate CSR
        $data = array(
            'resellerID' => $resellerid,
            'apiKey' => $apikey,
            'numOfYears' => $validityperiod,
            'city' => $city,
            'state' => $state,
            'country' => $country,
            'organisation' => $orgname,
            'organisationUnit' => $jobtitle,
            'commonName' => $params['fields']["common_name"],
            'emailAddress' => $emailaddress,
        );

        if ($params['fields']["common_name"] == '') {
            $error = "You need to enter domain name.";
            return array("error" => $error);
        }

        DB::table('tblhosting')->where('id', $params['serviceid'])->update(['domain'=> $params['fields']['common_name']]);
        $output = synergywholesale_ssl_api('SSL_generateCSR', $data, $testmode);

        if ($output->status != 'OK') 
        {
            return array("error" => $output->errorMessage);
        }
            $fieldid=DB::table('tblcustomfields')->where('fieldname','LIKE', 'privKey%')->where('relid', '=', $params['packageid'])->value('id');
            $fieldval = DB::table('tblcustomfieldsvalues')->where('fieldid','=', $fieldid)->where('relid', '=', $params['serviceid'])->value('value');
    if(!$fieldval)
    {
       $data = ['fieldid' => $fieldid, 'relid' => $params['serviceid'], 'value'=>$output->privKey];
       DB::table('tblcustomfieldsvalues')->insert($data);
    }
    else
        DB::table('tblcustomfieldsvalues')->where('relid','=', $params['serviceid'])->where('fieldid','=', $fieldid)->update(['value' => $output->privKey]);
        $csr_api = $output->csr;
    }
 
    $data = [
        'resellerID' => $resellerid,
        'apiKey' => $apikey,
        'csr' => $csr_api ? $csr_api : $csr,
        'productID' => $sslid,
        'firstName' => $firstname,
        'lastName' => $lastname,
        'emailAddress' => $emailaddress,
        'address' => $address1,
        'city' => $city,
        'state' => $state,
        'postCode' => $postcode,
        'country' => $country,
        'phone' => $phonenumber,
        'fax' => $phonenumber
    ];
	
    $output = synergywholesale_ssl_api('SSL_purchaseSSLCertificate', $data, $testmode);
    if ($output->status == "OK") {
        $certID = $output->certID;
        return array("remoteid" => $certID, "provisioned" => 1, "expirydate" => date("Y-m-d", mktime(0, 0, 0, date("m") + $validityperiod, date("d"), date("Y"))));
    } else {
        $error = $output->errorMessage;
        if (!$error)
            $error = "An Unknown Error Occurred";
        return array("error" => $error);
    }
}



